/********************************** (C) COPYRIGHT *******************************
 * File Name          : Main.c
 * Author             : WCH
 * Version            : V1.0
 * Date               : 2020/08/06
 * Description        : ԶUSB豸CH372豸ṩ80ͨ(ϴ+´)ʵ´Ȼȡϴ
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * SPDX-License-Identifier: Apache-2.0
 *******************************************************************************/

#include "CH58x_common.h"

#define DevEP0SIZE    0x40
// 豸
const uint8_t MyDevDescr[] = { 0x12, 0x01, 0x10, 0x01, 0xFF, 0x80, 0x55, DevEP0SIZE, 0x48, 0x43, 0x37, 0x55,    // IDͲƷID
                             0x00, 0x01, 0x01, 0x02, 0x00, 0x01, };
// 
const uint8_t MyCfgDescr[] = { 0x09, 0x02, 0x4A, 0x00, 0x01, 0x01, 0x00, 0x80, 0x32, 0x09, 0x04, 0x00, 0x00, 0x08, 0xFF,
                             0x80, 0x55, 0x00, 0x07, 0x05, 0x84, 0x02, 0x40, 0x00, 0x00, 0x07, 0x05, 0x04, 0x02, 0x40,
                             0x00, 0x00, 0x07, 0x05, 0x83, 0x02, 0x40, 0x00, 0x00, 0x07, 0x05, 0x03, 0x02, 0x40, 0x00,
                             0x00, 0x07, 0x05, 0x82, 0x02, 0x40, 0x00, 0x00, 0x07, 0x05, 0x02, 0x02, 0x40, 0x00, 0x00,
                             0x07, 0x05, 0x81, 0x02, 0x40, 0x00, 0x00, 0x07, 0x05, 0x01, 0x02, 0x40, 0x00, 0x00, };
// 
const uint8_t MyLangDescr[] = {0x04, 0x03, 0x09, 0x04};
// Ϣ
const uint8_t MyManuInfo[] = {0x0E, 0x03, 'w', 0, 'c', 0, 'h', 0, '.', 0, 'c', 0, 'n', 0};
// ƷϢ
const uint8_t MyProdInfo[] = {0x0C, 0x03, 'C', 0, 'H', 0, '5', 0, '7', 0, 'x', 0};

/**********************************************************/
uint8_t        DevConfig;
uint8_t        SetupReqCode;
uint16_t       SetupReqLen;
const uint8_t *pDescr;

/******** ûԶ˵RAM ****************************************/
__attribute__((aligned(4))) uint8_t U2EP0_Databuf[64 + 64 + 64]; //ep0(64)+ep4_out(64)+ep4_in(64)
__attribute__((aligned(4))) uint8_t U2EP1_Databuf[64 + 64];      //ep1_out(64)+ep1_in(64)
__attribute__((aligned(4))) uint8_t U2EP2_Databuf[64 + 64];      //ep2_out(64)+ep2_in(64)
__attribute__((aligned(4))) uint8_t U2EP3_Databuf[64 + 64];      //ep3_out(64)+ep3_in(64)

/*********************************************************************
 * @fn      USB2_DevTransProcess
 *
 * @brief   USB2 䴦
 *
 * @return  none
 */
void USB2_DevTransProcess(void)
{
    uint8_t len, chtype;
    uint8_t intflag, errflag = 0;

    intflag = R8_USB2_INT_FG;
    if(intflag & RB_UIF_TRANSFER)
    {
        if((R8_USB2_INT_ST & MASK_UIS_TOKEN) != MASK_UIS_TOKEN) // ǿ
        {
            switch(R8_USB2_INT_ST & (MASK_UIS_TOKEN | MASK_UIS_ENDP))
            // ƺͶ˵
            {
                case UIS_TOKEN_IN:
                {
                    switch(SetupReqCode)
                    {
                        case USB_GET_DESCRIPTOR:
                            len = SetupReqLen >= DevEP0SIZE ? DevEP0SIZE : SetupReqLen; // δ䳤
                            memcpy(pU2EP0_DataBuf, pDescr, len);                          /* ϴ */
                            SetupReqLen -= len;
                            pDescr += len;
                            R8_U2EP0_T_LEN = len;
                            R8_U2EP0_CTRL ^= RB_UEP_T_TOG; // ת
                            break;
                        case USB_SET_ADDRESS:
                            R8_USB2_DEV_AD = (R8_USB2_DEV_AD & RB_UDA_GP_BIT) | SetupReqLen;
                            R8_U2EP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
                            break;
                        default:
                            R8_U2EP0_T_LEN = 0; // ״̬׶жϻǿϴ0ݰƴ
                            R8_U2EP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
                            break;
                    }
                }
                break;

                case UIS_TOKEN_OUT:
                    len = R8_USB2_RX_LEN;
                    break;

                case UIS_TOKEN_OUT | 1:
                {
                    if(R8_USB2_INT_ST & RB_UIS_TOG_OK)
                    { // ͬݰ
                        R8_U2EP1_CTRL ^= RB_UEP_R_TOG;
                        len = R8_USB2_RX_LEN;
                        DevEP1_OUT_Deal(len);
                    }
                }
                break;

                case UIS_TOKEN_IN | 1:
                R8_U2EP1_CTRL ^= RB_UEP_T_TOG;
                R8_U2EP1_CTRL = (R8_U2EP1_CTRL & ~MASK_UEP_T_RES) | UEP_T_RES_NAK;
                    break;

                case UIS_TOKEN_OUT | 2:
                {
                    if(R8_USB2_INT_ST & RB_UIS_TOG_OK)
                    { // ͬݰ
                        R8_U2EP2_CTRL ^= RB_UEP_R_TOG;
                        len = R8_USB2_RX_LEN;
                        DevEP2_OUT_Deal(len);
                    }
                }
                break;

                case UIS_TOKEN_IN | 2:
                    R8_U2EP2_CTRL ^= RB_UEP_T_TOG;
                    R8_U2EP2_CTRL = (R8_U2EP2_CTRL & ~MASK_UEP_T_RES) | UEP_T_RES_NAK;
                    break;

                case UIS_TOKEN_OUT | 3:
                {
                    if(R8_USB2_INT_ST & RB_UIS_TOG_OK)
                    { // ͬݰ
                        R8_U2EP3_CTRL ^= RB_UEP_R_TOG;
                        len = R8_USB2_RX_LEN;
                        DevEP3_OUT_Deal(len);
                    }
                }
                break;

                case UIS_TOKEN_IN | 3:
                R8_U2EP3_CTRL ^= RB_UEP_T_TOG;
                R8_U2EP3_CTRL = (R8_U2EP3_CTRL & ~MASK_UEP_T_RES) | UEP_T_RES_NAK;
                    break;

                case UIS_TOKEN_OUT | 4:
                {
                    if(R8_USB2_INT_ST & RB_UIS_TOG_OK)
                    {
                        R8_U2EP4_CTRL ^= RB_UEP_R_TOG;
                        len = R8_USB2_RX_LEN;
                        DevEP4_OUT_Deal(len);
                    }
                }
                break;

                case UIS_TOKEN_IN | 4:
                R8_U2EP4_CTRL ^= RB_UEP_T_TOG;
                R8_U2EP4_CTRL = (R8_U2EP4_CTRL & ~MASK_UEP_T_RES) | UEP_T_RES_NAK;
                    break;

                default:
                    break;
            }
            R8_USB2_INT_FG = RB_UIF_TRANSFER;
        }

        if(R8_USB2_INT_ST & RB_UIS_SETUP_ACT) // Setup
        {
            R8_U2EP0_CTRL = RB_UEP_R_TOG | RB_UEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_NAK;
            SetupReqLen = pU2SetupReqPak->wLength;
            SetupReqCode = pU2SetupReqPak->bRequest;
            chtype = pU2SetupReqPak->bRequestType;

            len = 0;
            errflag = 0;
            if((pU2SetupReqPak->bRequestType & USB_REQ_TYP_MASK) != USB_REQ_TYP_STANDARD)
            {
                errflag = 0xFF; /* Ǳ׼ */
            }
            else /* ׼ */
            {
                switch(SetupReqCode)
                {
                    case USB_GET_DESCRIPTOR:
                    {
                        switch(((pU2SetupReqPak->wValue) >> 8))
                        {
                            case USB_DESCR_TYP_DEVICE:
                            {
                                pDescr = MyDevDescr;
                                len = MyDevDescr[0];
                            }
                            break;

                            case USB_DESCR_TYP_CONFIG:
                            {
                                pDescr = MyCfgDescr;
                                len = MyCfgDescr[2];
                            }
                            break;

                            case USB_DESCR_TYP_STRING:
                            {
                                switch((pU2SetupReqPak->wValue) & 0xff)
                                {
                                    case 1:
                                        pDescr = MyManuInfo;
                                        len = MyManuInfo[0];
                                        break;
                                    case 2:
                                        pDescr = MyProdInfo;
                                        len = MyProdInfo[0];
                                        break;
                                    case 0:
                                        pDescr = MyLangDescr;
                                        len = MyLangDescr[0];
                                        break;
                                    default:
                                        errflag = 0xFF; // ֵַ֧
                                        break;
                                }
                            }
                            break;

                            default:
                                errflag = 0xff;
                                break;
                        }
                        if(SetupReqLen > len)
                            SetupReqLen = len; //ʵϴܳ
                        len = (SetupReqLen >= DevEP0SIZE) ? DevEP0SIZE : SetupReqLen;
                        memcpy(pU2EP0_DataBuf, pDescr, len);
                        pDescr += len;
                    }
                    break;

                    case USB_SET_ADDRESS:
                        SetupReqLen = (pU2SetupReqPak->wValue) & 0xff;
                        break;

                    case USB_GET_CONFIGURATION:
                        pU2EP0_DataBuf[0] = DevConfig;
                        if(SetupReqLen > 1)
                            SetupReqLen = 1;
                        break;

                    case USB_SET_CONFIGURATION:
                        DevConfig = (pU2SetupReqPak->wValue) & 0xff;
                        break;

                    case USB_CLEAR_FEATURE:
                    {
                        if((pU2SetupReqPak->bRequestType & USB_REQ_RECIP_MASK) == USB_REQ_RECIP_ENDP) // ˵
                        {
                            switch((pU2SetupReqPak->wIndex) & 0xff)
                            {
                                case 0x82:
                                    R8_U2EP2_CTRL = (R8_U2EP2_CTRL & ~(RB_UEP_T_TOG | MASK_UEP_T_RES)) | UEP_T_RES_NAK;
                                    break;
                                case 0x02:
                                    R8_U2EP2_CTRL = (R8_U2EP2_CTRL & ~(RB_UEP_R_TOG | MASK_UEP_R_RES)) | UEP_R_RES_ACK;
                                    break;
                                case 0x81:
                                    R8_U2EP1_CTRL = (R8_U2EP1_CTRL & ~(RB_UEP_T_TOG | MASK_UEP_T_RES)) | UEP_T_RES_NAK;
                                    break;
                                case 0x01:
                                    R8_U2EP1_CTRL = (R8_U2EP1_CTRL & ~(RB_UEP_R_TOG | MASK_UEP_R_RES)) | UEP_R_RES_ACK;
                                    break;
                                default:
                                    errflag = 0xFF; // ֵ֧Ķ˵
                                    break;
                            }
                        }
                        else
                            errflag = 0xFF;
                    }
                    break;

                    case USB_GET_INTERFACE:
                        pU2EP0_DataBuf[0] = 0x00;
                        if(SetupReqLen > 1)
                            SetupReqLen = 1;
                        break;

                    case USB_GET_STATUS:
                        pU2EP0_DataBuf[0] = 0x00;
                        pU2EP0_DataBuf[1] = 0x00;
                        if(SetupReqLen > 2)
                            SetupReqLen = 2;
                        break;

                    default:
                        errflag = 0xff;
                        break;
                }
            }
            if(errflag == 0xff) // ֧
            {
                //                  SetupReqCode = 0xFF;
                R8_U2EP0_CTRL = RB_UEP_R_TOG | RB_UEP_T_TOG | UEP_R_RES_STALL | UEP_T_RES_STALL; // STALL
            }
            else
            {
                if(chtype & 0x80) // ϴ
                {
                    len = (SetupReqLen > DevEP0SIZE) ? DevEP0SIZE : SetupReqLen;
                    SetupReqLen -= len;
                }
                else
                    len = 0; // ´
                R8_U2EP0_T_LEN = len;
                R8_U2EP0_CTRL = RB_UEP_R_TOG | RB_UEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK; // ĬݰDATA1
            }

            R8_USB2_INT_FG = RB_UIF_TRANSFER;
        }
    }
    else if(intflag & RB_UIF_BUS_RST)
    {
        R8_USB2_DEV_AD = 0;
        R8_U2EP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
        R8_U2EP1_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
        R8_U2EP2_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
        R8_U2EP3_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
        R8_USB2_INT_FG = RB_UIF_BUS_RST;
    }
    else if(intflag & RB_UIF_SUSPEND)
    {
        if(R8_USB2_MIS_ST & RB_UMS_SUSPEND)
        {
            ;
        } // 
        else
        {
            ;
        } // 
        R8_USB2_INT_FG = RB_UIF_SUSPEND;
    }
    else
    {
        R8_USB2_INT_FG = intflag;
    }
}


/*********************************************************************
 * @fn      DebugInit
 *
 * @brief   Գʼ
 *
 * @return  none
 */
void DebugInit(void)
{
    GPIOA_SetBits(GPIO_Pin_9);
    GPIOA_ModeCfg(GPIO_Pin_8, GPIO_ModeIN_PU);
    GPIOA_ModeCfg(GPIO_Pin_9, GPIO_ModeOut_PP_5mA);
    UART1_DefInit();
}

/*********************************************************************
 * @fn      main
 *
 * @brief   
 *
 * @return  none
 */
int main()
{
    SetSysClock(CLK_SOURCE_PLL_60MHz);

    DebugInit();
    PRINT("start\n");

    pU2EP0_RAM_Addr  = U2EP0_Databuf;
    pU2EP1_RAM_Addr  = U2EP1_Databuf;
    pU2EP2_RAM_Addr  = U2EP2_Databuf;
    pU2EP3_RAM_Addr  = U2EP3_Databuf;
    USB2_DeviceInit();
    PFIC_EnableIRQ(USB2_IRQn);

    while(1);
}

/*********************************************************************
 * @fn      DevEP1_OUT_Deal
 *
 * @brief   ˵1ݴ
 *
 * @return  none
 */
void DevEP1_OUT_Deal(uint8_t l)
{ /* ûԶ */
    uint8_t i;

    for(i = 0; i < l; i++)
    {
        pU2EP1_IN_DataBuf[i] = ~pU2EP1_OUT_DataBuf[i];
    }
    U2DevEP1_IN_Deal(l);
}

/*********************************************************************
 * @fn      DevEP2_OUT_Deal
 *
 * @brief   ˵2ݴ
 *
 * @return  none
 */
void DevEP2_OUT_Deal(uint8_t l)
{ /* ûԶ */
    uint8_t i;

    for(i = 0; i < l; i++)
    {
        pU2EP2_IN_DataBuf[i] = ~pU2EP2_OUT_DataBuf[i];
    }
    U2DevEP2_IN_Deal(l);
}

/*********************************************************************
 * @fn      DevEP3_OUT_Deal
 *
 * @brief   ˵3ݴ
 *
 * @return  none
 */
void DevEP3_OUT_Deal(uint8_t l)
{ /* ûԶ */
    uint8_t i;

    for(i = 0; i < l; i++)
    {
        pU2EP3_IN_DataBuf[i] = ~pU2EP3_OUT_DataBuf[i];
    }
    U2DevEP3_IN_Deal(l);
}

/*********************************************************************
 * @fn      DevEP4_OUT_Deal
 *
 * @brief   ˵4ݴ
 *
 * @return  none
 */
void DevEP4_OUT_Deal(uint8_t l)
{ /* ûԶ */
    uint8_t i;

    for(i = 0; i < l; i++)
    {
        pU2EP4_IN_DataBuf[i] = ~pU2EP4_OUT_DataBuf[i];
    }
    U2DevEP4_IN_Deal(l);
}

/*********************************************************************
 * @fn      USB_IRQHandler
 *
 * @brief   USBжϺ
 *
 * @return  none
 */
__INTERRUPT
__HIGH_CODE
void USB2_IRQHandler(void) /* USBжϷ,ʹüĴ1 */
{
    USB2_DevTransProcess();
}
